var aSession = {
	isObserver: true,
	adsInjected:false,
	ajaxURL:{},
	urlToDomain:{},
	

	getWindowForRequest:function(request) {
		//return gBrowser.contentWindow;
		if (request instanceof Components.interfaces.nsIRequest) {
			try {
				if (request.notificationCallbacks) {
					return request.notificationCallbacks
					.getInterface(Components.interfaces.nsILoadContext)
					.associatedWindow;
				}
			} catch (e) {}//dump(request.URI.spec+"\n");}
			try {
				if (request.loadGroup && request.loadGroup.notificationCallbacks) {
					return request.loadGroup.notificationCallbacks
					.getInterface(Components.interfaces.nsILoadContext)
					.associatedWindow;
				}
			} catch (e) {}//dump(request.URI.spec+"\n");}
		}
		return null;
	},

	httpRequestObserver: {
		observe: function(aSubject, aTopic, aData){	
			if (aTopic == "http-on-examine-response") {
				aSubject.QueryInterface(Ci.nsIHttpChannel);
				var tmpDomain = getDomain(aSubject.originalURI.spec);
//				try {
//					var tmpDomain = getDomain(aSubject.originalURI);
//				} catch (e) {
//					if (aSubject.originalURI.host === "s3.amazonaws.com")
//						return "amazonaws.com"; // weird, why does it fail?
//					if (aSubject.originalURI.host.match(/\d+\.\d+\.\d+\.\d+/))
//						return aSubject.originalURI.host.replace(/\./g, "-");
//					dump("Invalid TLD: " + aSubject.originalURI.spec + "\n");
//					return;
//				}
				var newListener = new TracingListener();
				aSubject.QueryInterface(Ci.nsITraceableChannel);
				newListener.originalListener = aSubject.setNewListener(newListener);
				newListener.url = aSubject.URI.spec;
				newListener.originalURL = aSubject.originalURI.spec;
				newListener.domain = tmpDomain;
				newListener.contentType = aSubject.contentType;	
				newListener.hostURL = aSession.hostURL;
				newListener.hostDomain = aSession.hostDomain;
				newListener.window = aSession.getWindowForRequest(aSubject);	
				if (newListener.window){					
					dump("Request for url " + newListener.originalURL.substring(0,100) + " is from window having url " + newListener.window.location.href.substring(0,100) + "\n\n");
				}
				else {
					dump("NULL WINDOW - Request for url " + newListener.originalURL + "\n");
				}
			}	
			
			/*if (aTopic == "http-on-modify-request") {
				aSubject.QueryInterface(Ci.nsIHttpChannel);
				//dump('get request for ' + aSubject.URI.spec + ' >>time:'+ new Date().getTime() +"\n");
			}*/
		},

		get observerService() {
			return Cc["@mozilla.org/observer-service;1"]
			.getService(Ci.nsIObserverService);
		},

		register: function(){
			this.observerService.addObserver(this, "http-on-examine-response", false);
			//this.observerService.addObserver(this, "http-on-modify-request", false);
			aSession.isObserver = true;					
		},

		unregister: function(){
			if (aSession.isObserver){
				//this.observerService.removeObserver(this, "http-on-examine-response");
				//this.observerService.removeObserver(this, "http-on-modify-request");
				aSession.isObserver = false;
			}
		}

	},

	getScriptUID: function(){
		aSession.scriptUID = aSession.scriptUID + 1;
		return "confinedScript" + aSession.scriptUID;
	},

	getURL: function(){
		return aSession.hostURL;
	},	
	
	setDoc: function(doc){
		if (aSession.isObserver){
			dump((ads_app_is_enabled?"****Platform is on****\n":"****Platform is off****\n"));
			dump("NEW HOST:" + doc.location.href +"\n");
			aSession.hostURL = doc.location.href;
			aSession.hostDomain = getDomain(aSession.hostURL);
			aSession.adsInjected = false;
			aSession.scriptUID = 0;		
			aSession.ajaxURL = {};			
			aSession.urlSrc = {};
			aSession.urlToDomain = {}; // to store principal of a url
			aSession.rewrittenSources = {};
		}
	}	
}


	